<template>
  <div class="budget-list-wrap">
    <DeleteDialog
      :dialogVisible="showDeleteDialog"
      @confirmDelete="confirmDelete"
      @cancelDelete="cancelDelete"
    />
    <template v-if="!isEmpty">
      <ElCard :header="listName">
        <div class="list-item" v-for="(item, prop) in list" v-bind:key="prop">
          <span class="budget-comment">{{ item.comment }}</span>
          <span
            :class="{
              positiveValue: item.value > 0,
              negativeValue: item.value < 0,
            }"
            class="budget-value"
            >{{ item.value }}</span
          >
          <div class="arrow-type">
            <template v-if="item.value > 0">
              <i class="el-icon-top"></i>
            </template>
            <template v-if="item.value < 0">
              <i class="el-icon-bottom"></i>
            </template>
          </div>
          <ElButton type="danger" size="mini" @click="deleteItem(item.id)"
            >Delete</ElButton
          >
        </div>
      </ElCard>
    </template>
    <ElAlert v-else type="info" :title="emptyTitle" :closable="false" />
  </div>
</template>

<script>
import DeleteDialog from "@/components/DeleteDialog";
export default {
  components: {
    DeleteDialog,
  },
  name: "BudgetList",
  props: {
    list: {
      type: Object,
      default: () => ({}),
    },
  },
  computed: {
    isEmpty() {
      return !Object.keys(this.list).length;
    },
  },
  data: () => ({
    listName: "История операций",
    emptyTitle: "Нет операций",
    showDeleteDialog: false,
    idToDelete: "",
  }),

  methods: {
    confirmDelete() {
      this.showDeleteDialog = false;
      this.$emit("deleteItem", this.idToDelete);
      this.idToDelete = "";
    },
    deleteItem(id) {
      this.idToDelete = id;
      this.showDeleteDialog = true;
    },
    cancelDelete() {
      this.showDeleteDialog = false;
    },
  },
};
</script>

<style scoped>
.budget-list-wrap {
  max-width: 500px;
  margin: auto;
}
.list-item {
  display: flex;
  align-items: center;
  padding: 10px, 15px;
}
.budget-value {
  font-weight: bold;
  margin-left: auto;
  margin-right: 10px;
}
.positiveValue {
  color: green;
}
.negativeValue {
  color: red;
}
.arrow-type {
  margin-right: 10px;
}
</style>
